/*
 * main.c
 * 
 * Version 01-11-2018
 * 
 * 
 * Copyright 2018 Gerhard Hinze <gerhard@gerhard-CELSIUS-W370>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of thVersion 01-11-2018e GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA..
 * 
 * 
 */

 /* 
 * Geany Erstellen-Einstellungen für STK500 mit ATmega32
 * 
 * Compil.:  avr-gcc -mmcu=atmega32 -Os %f
 * 
 * Build  :  avr-objcopy -j .text -j .data -O ihex a.out
 * 
 * Flash  :  avrdude -c stk500 -P /dev/ttyS0 -p m32   -U flash:w:a.out
 * 
 * Exec-AVRDude : avrdude -c stk500 -P /dev/ttyS0 -p m32   -U flash:w:a.out
*/

#ifndef F_CPU
#define F_CPU  3686400UL  //STK500
// #define F_CPU  8000000UL  // ATM128 Board
// #define F_CPU  16000000UL // beliebig, auch Arduino
#endif  //F_CPU


#ifndef BAUD
#define BAUD 9600UL  //UL wichtig !!!!!!!!!!!!!!!!!!!!!!!
#endif

/*====================================================================*/
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*====================================================================*/


#include <stdlib.h>
#include <string.h>
#include <avr/interrupt.h>

#include <util/delay.h>

#include "ds18b20/ds18b20.c"

#include "uart/ol_avr_uart.c"

/*====================================================================*/
/*                                                                    */
/*         Programm initialisieren, Start-Subroutinen starten         */
/*                                                                    */
/*                                                                    */
/*====================================================================*/


void main_init()
{
	UART_Init();
}

/*====================================================================*/
/*                                                                    */
/*          Hauptprogramm                                             */
/*                                                                    */
/*                                                                    */
/*====================================================================*/


int main(void) {
	char printbuff[100];
	double d = 0;
	
	main_init();
	
	// IRQ enable
	sei();
    // Endlosschleife
	for (;;) {
	int	d = ds18b20_gettemp();  
	
	// Temperaturausgabe formatieren und kopieren in "printbuff"
	dtostrf(d, 10, 3, printbuff); // 2 stellig hinterm Komma
	
	UART_Write_Text("Temperatur: "); 
	UART_Printf(printbuff);
	// Grad und Celsius nach Temp Wert Drucken n. bearbeiten
	UART_Write_NL();
    //UART_Write_Int_NL(d);
		_delay_ms(1500);
	}
	
	return 0;
}

/*====================================================================*/
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*====================================================================*/

