/*
 * ol_avr_uart.h
 * 
 * Version 01.1-11-2018
 * 
 * 
 * Copyright 2018 Gerhard Hinze <gerhard@gerhard-CELSIUS-W370>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA..
 * 
 * 
 */



/* ================================================================== */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/* ================================================================== */
#ifndef _OL_AVR_UART_H_
#define _OL_AVR_UART_H_

#ifndef F_CPU
#define F_CPU  3686400UL  //STK500
// #define F_CPU  8000000UL  // ATM128 Board
// #define F_CPU  16000000UL // beliebig, auch Arduino
#endif  //F_CPU

/* ================================================================== */
/*                                                                    */
/*           Includieren der benötigten Headerdateien                 */
/*                                                                    */
/*                                                                    */
/* ================================================================== */

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>


/* ================================================================== */
/*                                                                    */
/*           Eigene Definitionen                                      */
/*                                                                    */
/*                                                                    */
/* ================================================================== */

#ifndef BAUD
#define BAUD 9600UL  //UL wichtig !!!!!!!!!!!!!!!!!!!!!!!
#endif

#define UBRR_VALUE (((F_CPU/(16*BAUD))-1))
#ifndef UCHR
#define UCHR unsigned char
#endif

/* ================================================================== */
/*                                                                    */
/*           Prototypen der Funktionen/Routinen                       */
/*                                                                    */
/* ================================================================== */
    
void UART_Init();
UCHR UART_Read();
void UART_Read_Text(UCHR *Output, unsigned int length);
void UART_Write(UCHR data);
void UART_Write_Text(UCHR *text);
void UART_Write_Text_NL(UCHR *text);
void UART_Write_NL();
void UART_Write_Int(int zahl);
void UART_Write_Int_NL(int zahl);
void UART_Printf(char *chr);
void serial_echo();
void serial_test();
/* ================================================================== */


/* ================================================================== */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/* ================================================================== */

/* ================================================================== */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/* ================================================================== */

/* ================================================================== */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/* ================================================================== */


/* ================================================================== */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/*                                                                    */
/* ================================================================== */

#endif  // _OL_AVR_UART_H_
